// by GST378
// Gamertag: Gusta 23324585
import { ActionFormData, MessageFormData } from "@minecraft/server-ui"
import { world, system } from "@minecraft/server"

class Mains {

    Credits(player) {
        const form = new ActionFormData()
            .title({translate: 'gst.title.credits'})
            .body({"rawtext":[{"translate":"gst.body.credits"},{"text":"\n\n"},{"translate":"gst.body.map_name"},{"text":"\n§7Minecraft Bedrock 1.20.70 +§r\n"},{"translate":"gst.body.author"},{"text":"\n\n§aGamertag:§f Gusta 23324585§r"}]})
            .button({translate: 'gst.button.credits'}) //0
        
        form.show(player).then((data) => {
            if (data.selection === 0) {
                player.runCommandAsync('titleraw @s actionbar {"rawtext":[{"translate":"gst.button.credits.selected"}]}');
            }
        })
    }
    
    Info(player) {
        const form = new ActionFormData()
            .title({translate: 'gst.title.info'})
            .body({"rawtext":[{"translate":"gst.info.text_1"},{"text":"\n"},{"translate":"gst.info.text_2"},{"text":"\n\n"},{"translate":"gst.info.text_3"},{"text":"\n"},{"translate":"gst.info.text_4"},{"text":"\n"},{"translate":"gst.info.text_5"},{"text":"\n"},{"translate":"gst.info.text_6"},{"text":"\n\n"},{"translate":"gst.info.text_7"},{"text":"\n\n"},{"translate":"gst.info.text_8"},{"text":"\n"},{"translate":"gst.info.text_9"}]})
            .button({translate: 'gst.button.info_stats'}, 'textures/gst/ui/info_menu/stats') //0
            .button({translate: 'gst.button.info_advanced'},'textures/gst/ui/info_menu/advanced') //1
            .button({translate: 'gst.button.info'}) //2
        
        form.show(player).then((data) => {
            if (data.selection === 0) {
                player.runCommandAsync('scriptevent gst:stats');
            }
            if (data.selection === 1) {
                player.runCommandAsync('scriptevent gst:advanced');
            }
        })
    }

    Skins(player) {
        const form = new ActionFormData()
            .title({translate: 'gst.title.skins'})
            .body({translate: 'gst.body.skins'})
            .button({translate: 'gst.button_0.skins'}, 'textures/gst/spaceship_player/spaceship_blue') // 0 
            .button({translate: 'gst.button_1.skins'}, 'textures/gst/spaceship_player/spaceship_green')// 1
            .button({translate: 'gst.button_2.skins'}, 'textures/gst/spaceship_player/spaceship_orange')// 2
            .button({translate: 'gst.button_3.skins'}, 'textures/gst/spaceship_player/spaceship_purple')// 3
            .button({translate: 'gst.button_4.skins'}, 'textures/gst/spaceship_player/spaceship_red')// 4
            .button({translate: 'gst.button_5.skins'}, 'textures/gst/spaceship_player/spaceship_yellow')// 5
        
        form.show(player).then((data) => {
            if (data.selection === 0) {
                player.runCommandAsync('titleraw @s actionbar {"rawtext":[{"translate":"gst.button_0.skins.selected"}]}');
                player.runCommandAsync('tag @s add skins');
                player.triggerEvent('gst:blue');
            }
            if (data.selection === 1) {
                player.runCommandAsync('titleraw @s actionbar {"rawtext":[{"translate":"gst.button_1.skins.selected"}]}');
                player.runCommandAsync('tag @s add skins');
                player.triggerEvent('gst:green');
            }
            if (data.selection === 2) {
                player.runCommandAsync('titleraw @s actionbar {"rawtext":[{"translate":"gst.button_2.skins.selected"}]}');
                player.runCommandAsync('tag @s add skins');
                player.triggerEvent('gst:orange');
            }
            if (data.selection === 3) {
                player.runCommandAsync('titleraw @s actionbar {"rawtext":[{"translate":"gst.button_3.skins.selected"}]}');
                player.runCommandAsync('tag @s add skins');
                player.triggerEvent('gst:purple');
            }
            if (data.selection === 4) {
                player.runCommandAsync('titleraw @s actionbar {"rawtext":[{"translate":"gst.button_4.skins.selected"}]}');
                player.runCommandAsync('tag @s add skins');
                player.triggerEvent('gst:red');
            }
            if (data.selection === 5) {
                player.runCommandAsync('titleraw @s actionbar {"rawtext":[{"translate":"gst.button_5.skins.selected"}]}');
                player.runCommandAsync('tag @s add skins');
                player.triggerEvent('gst:yellow');
            }
        })
    }
    
    Play(player) {
        const form = new ActionFormData()
            .title({translate: 'gst.title.play'})
            .body({translate: 'gst.body.play'})
            form.button({translate: 'gst.button.levels'},'textures/gst/ui/play_menu/levels') //0
            if(player.level < 10){form.button({"rawtext":[{"translate":"gst.button.endless"},{"text":"§r\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //1
            if(player.level >= 10){form.button({translate: 'gst.button.endless'},'textures/gst/ui/play_menu/endless')} //1
            form.button({translate: 'gst.button.cancel'}) //2
        
        form.show(player).then((data) => {
            if (data.selection === 0) {
                player.runCommandAsync('scriptevent gst:levels');
            }
            if (data.selection === 1) {
                player.runCommandAsync('tellraw @s[scores={completed_levels=..9}] {"rawtext":[{"translate":"gst.endless.locked"}]}');
                player.runCommandAsync('execute if entity @s[scores={completed_levels=10..}] run event entity @s gst:set_spaceship');
                player.runCommandAsync('execute if entity @s[scores={completed_levels=10..}] run camera @s fade time 0 1 0 color 0 0 0');
                player.runCommandAsync('execute if entity @s[scores={completed_levels=10..}] run camera @s set minecraft:free pos 0 -49 6 rot 90 0');
                player.runCommandAsync('execute if entity @s[scores={completed_levels=10..}] run setblock 6 -60 -1 redstone_block');
            }
        })
    }
    
    Levels(player) {
        const form = new ActionFormData()
            .title({translate: 'gst.title.levels'})
            if(player.level >= 0){form.button({translate: 'gst.button.level_1'},'textures/gst/ui/levels/1')} //0
            if(player.level < 1){form.button({"rawtext":[{"translate":"gst.button.level_2"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //1
            if(player.level >= 1){form.button({translate: 'gst.button.level_2'},'textures/gst/ui/levels/2')} //1
            if(player.level < 2){form.button({"rawtext":[{"translate":"gst.button.level_3"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //2
            if(player.level >= 2){form.button({translate: 'gst.button.level_3'},'textures/gst/ui/levels/3')} //2
            if(player.level < 3){form.button({"rawtext":[{"translate":"gst.button.level_4"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //3
            if(player.level >= 3){form.button({translate: 'gst.button.level_4'},'textures/gst/ui/levels/4')} //3
            if(player.level < 4){form.button({"rawtext":[{"translate":"gst.button.level_5"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //4
            if(player.level >= 4){form.button({translate: 'gst.button.level_5'},'textures/gst/ui/levels/5')} //4
            if(player.level < 5){form.button({"rawtext":[{"translate":"gst.button.level_6"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //5
            if(player.level >= 5){form.button({translate: 'gst.button.level_6'},'textures/gst/ui/levels/6')} //5
            if(player.level < 6){form.button({"rawtext":[{"translate":"gst.button.level_7"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //6
            if(player.level >= 6){form.button({translate: 'gst.button.level_7'},'textures/gst/ui/levels/7')} //6
            if(player.level < 7){form.button({"rawtext":[{"translate":"gst.button.level_8"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //7
            if(player.level >= 7){form.button({translate: 'gst.button.level_8'},'textures/gst/ui/levels/8')} //7
            if(player.level < 8){form.button({"rawtext":[{"translate":"gst.button.level_9"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //8
            if(player.level >= 8){form.button({translate: 'gst.button.level_9'},'textures/gst/ui/levels/9')} //8
            if(player.level < 9){form.button({"rawtext":[{"translate":"gst.button.level_10"},{"text":"\n"},{"translate":"gst.locked"}]},'textures/gst/ui/levels/locked')} //9
            if(player.level >= 9){form.button({translate: 'gst.button.level_10'},'textures/gst/ui/levels/10')} //9
            if(player.level >= 0){form.button({translate: 'gst.button.back'})} //10
        
        form.show(player).then((data) => {
            if (data.selection === 0) {
                player.runCommandAsync('structure load level_1 -7 -57 -27');
                player.runCommandAsync('scoreboard players set @s gst_levels 1');
            }
            if (data.selection === 1) {
                player.runCommandAsync('execute as @s[scores={completed_levels=1..}] run structure load level_2 -11 -57 -27');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=1..}] gst_levels 2');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..0}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 2) {
                player.runCommandAsync('execute as @s[scores={completed_levels=2..}] run structure load level_3 -15 -57 -27');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=2..}] gst_levels 3');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..1}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 3) {
                player.runCommandAsync('execute as @s[scores={completed_levels=3..}] run structure load level_4 -19 -57 -27');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=3..}] gst_levels 4');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..2}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 4) {
                player.runCommandAsync('execute as @s[scores={completed_levels=4..}] run structure load level_5 -23 -57 -27');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=4..}] gst_levels 5');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..3}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 5) {
                player.runCommandAsync('execute as @s[scores={completed_levels=5..}] run structure load level_6 -7 -51 -40');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=5..}] gst_levels 6');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..4}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 6) {
                player.runCommandAsync('execute as @s[scores={completed_levels=6..}] run structure load level_7 -11 -51 -40');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=6..}] gst_levels 7');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..5}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 7) {
                player.runCommandAsync('execute as @s[scores={completed_levels=7..}] run structure load level_8 -15 -51 -40');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=7..}] gst_levels 8');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..6}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 8) {
                player.runCommandAsync('execute as @s[scores={completed_levels=8..}] run structure load level_9 -19 -51 -40');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=8..}] gst_levels 9');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..7}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 9) {
                player.runCommandAsync('execute as @s[scores={completed_levels=9..}] run structure load level_10 -23 -51 -40');
                player.runCommandAsync('scoreboard players set @s[scores={completed_levels=9..}] gst_levels 10');
                player.runCommandAsync('tellraw @s[scores={completed_levels=..8}] {"rawtext":[{"translate":"gst.locked.level"}]}');
            }
            if (data.selection === 10) {
                player.runCommandAsync('scoreboard players set @s gst_levels 0');
                player.runCommandAsync('scriptevent gst:play');
            }
        })
    }
    Reset(player) {
        const form = new MessageFormData()
            .title({translate: 'gst.title.reset'})
            .body({"rawtext":[{"translate":"gst.body.reset_0"},{"text":"\n"},{"translate":"gst.body.reset_1"}]})
            .button2({translate: 'gst.button.reset'}) //1
            .button1({translate: 'gst.button.cancel'}) //0
        
        form.show(player).then((data) => {
            if (data.canceled) return;
            
            if (data.selection === 1) {
                player.runCommandAsync('tag @s add reset');
                world.sendMessage({translate:'gst.map.reset'});
            }
            if (data.selection === 0) {
               player.runCommandAsync('tag @s remove reset');
            }
        })
    }
    Stats(player) {
        const form = new ActionFormData()
            .title({translate: 'gst.title.stats'})
            .body({"rawtext":[{"translate":"gst.levels.stats"},{"text":"\n\n"},{"translate":"gst.stats.completed_levels"},{"score":{"name":"*","objective":"completed_levels"}},{"text":"§e/10§r\n"},{"translate":"gst.stats.death"},{"score":{"name":"*","objective":"deaths_levels"}},{"text":"§r\n"},{"translate":"gst.stats.wins"},{"score":{"name":"*","objective":"gst_wins"}},{"text":"§r\n\n"},{"translate":"gst.endless.stats"},{"text":"\n\n"},{"translate":"gst.stats.death"},{"score":{"name":"*","objective":"deaths_endless"}},{"text":"\n"},{"translate":"gst.endless.highest_score"},{"score":{"name":"*","objective":"e_score_h"}},{"text":"\n\n"}]})
            .button({translate: 'gst.button.back'}) //0
        
        form.show(player).then((data) => {
            if (data.selection === 0) {
                player.runCommandAsync('scriptevent gst:info');
            }
        })
    }
    Advanced(player) {
        const form = new ActionFormData()
            .title({translate: 'gst.title.advanced'})
            .body({"rawtext":[{"translate":"gst.advanced.text_1"},{"text":"\n\n"},{"translate":"gst.advanced.text_2"},{"text":"\n\n"},{"translate":"gst.advanced.text_3"}]})
            .button({translate: 'gst.button.skip_level'},'textures/gst/ui/levels/skip_level') //0
            .button({translate: 'gst.button.reset_map'},'textures/gst/ui/reset_map') //1
            .button({translate: 'gst.button.back'}) //2
        
        form.show(player).then((data) => {
            if (data.selection === 0) {
                player.runCommandAsync('function gst/levels/skip_level');
            }
            if (data.selection === 1) {
                player.runCommandAsync('function gst/system/reset');
                world.sendMessage({translate:'gst.map.reset'});
            }
            if (data.selection === 2) {
                player.runCommandAsync('scriptevent gst:info');
            }
        })
    }
}

export const Main = new Mains()

world.afterEvents.itemUse.subscribe(e => {
    if (e.itemStack.typeId === "gst:reset") {
        Main.Reset(e.source)
    }
})

system.afterEvents.scriptEventReceive.subscribe(data => {
    const id = data.id
    const player = data.sourceEntity
    if (id === "gst:play") {
        Main.Play(player)
    }
    if (id === "gst:levels") {
        Main.Levels(player)
    }
    if (id === "gst:info") {
        Main.Info(player)
    }
    if (id === "gst:stats") {
        Main.Stats(player)
    }
    if (id === "gst:skins") {
        Main.Skins(player)
    }
    if (id === "gst:credits") {
        Main.Credits(player)
    }
    if (id === "gst:advanced") {
        Main.Advanced(player)
    }
})